#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class MyRendererColorButton < Gtk::ColorButton
	include ManqodCommon
	include Conf
  def initialize(pc)
		@pc=pc
		super()
		set_use_alpha(false)
		signal_connect('clicked'){|me|
			edebug("#{item['default']} clicked","gtk_button","debug")
			run_events(item['id'],'form_item-Action')
		}
  end
  attr_accessor :pc

  def update(new_value=item['default'])
		item['default']=new_value
		run_events(item['id'],'form_item-BeforeUpdate')
		begin
			set_color(Gdk::Color.parse("##{item['default']}"))
		rescue => err
			ewarn("#{item['default'].inspect} not a valid color")
		end
		edebug(item['default'].to_s+" updated","gtk_button","info")
		run_events(item['id'],'form_item-AfterUpdate')
  end

  def text
  	t=""
		color.to_a.each{|i| t="#{t}#{sprintf("%02x",i/255)}"}
		t
  end

  def parentM
		pc.parentM
  end
  
  def target
		nil
  end
  def item
		pc.item
  end
  def inspect
		"ColorButton(#{item['description']})"
	end
	def to_s
		inspect
	end

end
