#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class MyRendererCombo < Gtk::ComboBox
	include ManqodCommon
	include GtkAttributes
	
	def initialize(pc)
		@pc=pc
		super(false)
		item['wantnew']=true
		set_model(MyRendererModel.new(self))
		signal_connect('changed'){|me| 
			edebug(inspect+" '#{item['data']}' changed to item #{me.active.inspect}","form-combo","debug")
			pc.changed
			pc.notify_observers(self)
			edebug("'#{item['data']}' emiting 'changed' to observers","form-combo","debug")
			run_events(item['id'],'form_item-Action')
		}
	end	
		
	attr_accessor :pc
		
	def item
		pc.item
	end
	
		
	def update(new_value=item['default'])
		item['default']=new_value
		edebug("update called for #{inspect}, setting value #{new_value}","form-combo","debug")
		run_events(item['id'],'form_item-BeforeUpdate')
		model.update
		select_value(item['default'])
		run_events(item['id'],'form_item-AfterUpdate')
  end
		
	def get_value_from_text(selected_combo_text)
		selected_combo_value=nil
		model.mymodel.each {|model, path, iter| selected_combo_value=iter[0] if iter[1]==selected_combo_text }
		return selected_combo_value
	end
	  
	def get_text_from_value(selected_combo_value)
		selected_combo_text=nil
		model.mymodel.each {|model, path, iter| selected_combo_text=iter[0] if iter[1]==selected_combo_value }
		return selected_combo_text
	end
		
	def text
		if active_iter
			self.active_iter[0]
			else
			""
		end
	end

	def select_value(selected_value=item['default'])
	  item['default']=selected_value.to_s
	  found_and_selected=false
	  model.mymodel.each {|m, path, iter|  
			if iter[0]==item['default']
				set_active_iter(model.convert_child_iter_to_iter(iter))
				found_and_selected=true
			end
	  }
	  found_and_selected
	end

	def parentselected
		pc.parentselected
  end
  def parentM
		pc.parentM
  end
  def to_s
		"Combo(#{item['description']})"
  end
	  
end

