#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class MyRendererComboWithNew < Gtk::HBox
	include ManqodCommon
  include Myform
	include GtkAttributes
  class ComboButton < Gtk::Button
  	include ManqodCommon
		include Observable
		def initialize
			super()
	  	set_label("")
			set_image(Gtk::Image.new(Gtk::Stock::INDEX,Gtk::IconSize::MENU))
			set_relief(Gtk::ReliefStyle::NONE)
		end
		
		def update(notifier)
			set_image(Gtk::Image.new(
			case notifier.parentM.runmode
				when "info" then Gtk::Stock::INFO
				when "wysiwygf" then Gtk::Stock::PROPERTIES
				else (notifier.text=="-1" || notifier.text=="" ? Gtk::Stock::ADD : Gtk::Stock::EDIT )
			end ,Gtk::IconSize::MENU))
		end
	end
	
	def initialize(pc)
		@pc=pc
		item['wantnew']=true
		super()
		@combo=MyRendererCombo.new(pc)
		@button=ComboButton.new
		pc.add_observer(button)
		pack_start(combo,true,true,0) 
		button.signal_connect('clicked'){|c|
			@form=Myform::MyFormHolder.new("dialog",self,@pc.target_runmode,target)
			@form.set_parentM(parentM)
			ret=form.run(text.to_i)
			combo.update(ret) if ret and ret>0
		}
		pack_end(button,false,false,0) 
	end
	attr_accessor :combo
	attr_accessor :button
	attr_accessor :pc
	attr_accessor :form
  
	def update(to_select=item['default'])
		combo.update(to_select)
		button.update(combo)
	end
	
	def item
		pc.item
	end
	
	def text
		combo.text
	end
	
	def select_value(selected_value)
		combo.select_value(selected_value)
	end
	
	def get_text_from_value(selected_combo_value)
		combo.get_text_from_value(selected_combo_value)
	end
	
	def get_value_from_text(selected_combo_text)
		combo.get_value_from_text(selected_combo_text)
	end
  
	def target
		pc.target
	end
	
	def parentM
		pc.parentM
	end
	
	def query
		parentM.query
	end
	
	def set_sensitive(sens)
		@combo.set_sensitive(sens)
		self
	end
	
	def model
		combo.model
	end
	
	def qrow
		parentM.qrow
	end
  def inspect
		"Combo(#{item["description"]})"
  end

end
