#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class MyRendererDuration < Gtk::Table #Gtk::HBox
	include ManqodCommon
	def initialize(pc)
	  @pc=pc
	  super(4,2)
	  attach_defaults(Gtk::Label.new("day"),0,1,0,1)
	  attach_defaults(Gtk::Label.new("hour"),1,2,0,1)
	  attach_defaults(Gtk::Label.new("min"),2,3,0,1)
	  attach_defaults(Gtk::Label.new("sec"),3,4,0,1)

	  attach_defaults(@dw=Gtk::SpinButton.new(0,5*365,1).set_has_frame(false).set_numeric(true).set_increments(1,10).set_digits(0),0,1,1,2)
	  attach_defaults(@hw=Gtk::SpinButton.new(0,23,1).set_has_frame(false).set_numeric(true).set_increments(1,10).set_digits(0),1,2,1,2)
	  attach_defaults(@mw=Gtk::SpinButton.new(0,59,1).set_has_frame(false).set_numeric(true).set_increments(1,10).set_digits(0),2,3,1,2)
	  attach_defaults(@sw=Gtk::SpinButton.new(0,59,1).set_has_frame(false).set_numeric(true).set_increments(1,10).set_digits(0),3,4,1,2)
 		@sw.signal_connect('value_changed'){|me| changed}
 		@mw.signal_connect('value_changed'){|me| changed}
 		@hw.signal_connect('value_changed'){|me| changed}
 		@dw.signal_connect('value_changed'){|me| changed}
	end	
	attr_accessor :pc

	def item
		@pc.item
	end
	
	def update(new_value=item['default'])
	  item['default']=new_value.to_f
	  run_events(item['id'],'form_item-BeforeUpdate')
		pc.run_query
	  duration_to_wg(item['default'].to_f) if item['default']
#	  set_sensitive(item['editable']=="true")
	  run_events(item['id'],'form_item-AfterUpdate')
	end
	
	def wg_to_duration
		(@dw.value*24*3600+@hw.value*3600+@mw.value*60+@sw.value).round
	end
	def duration_to_wg(d)
		d,r=(d.to_f).divmod(24*3600)
		h,r=(r).divmod(3600)
		m,s=(r).divmod(60)
		@dw.set_value(d)
		@hw.set_value(h)
		@mw.set_value(m)
		@sw.set_value(s.round)
	end
	
	def text
		wg_to_duration.to_s
	end

	def parentselected
	  @pc.parentselected
	end
	
	def parentM
	  @pc.parentM
	end
	def changed
			edebug("#{self} changed to #{wg_to_duration}","form","debug")
			pc.changed
			pc.notify_observers(self)
			edebug("#{self} emiting 'changed' to observers","form","debug")
			run_events(item['id'],'form_item-Action')
	end
	def to_s;"Duration(#{item["description"]})";end

end

