#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class MyFileChooserButton < Gtk::FileChooserWidget
	include ManqodCommon
	include Conf
	def initialize(pc)
		@pc=pc
		action=case item['action']
			when 'load' then Gtk::FileChooser::Action::OPEN
			when 'save' then Gtk::FileChooser::Action::SAVE
		end
		super(action)
#	 set_select_multiple(false)
		path=get_conf(0,item['id'],"path")
		set_current_folder(path) if !path.nil?

		preview=Gtk::Image.new
		set_preview_widget(preview)
		signal_connect("update-preview") {
			filename = preview_filename
			begin
				have_pixbuf=true
				pixbuf = Gdk::Pixbuf.new(filename, 128, 128)
				rescue
					have_pixbuf=false
			end
			preview_widget.set_pixbuf(pixbuf)
			set_preview_widget_active(have_pixbuf)
		}
		begin
			@ftp=eval(pc.gtk_attribute("ftp-access").to_s)
		rescue =>err
			ewarn(err)
		end
		pack_start(@progress=Gtk::ProgressBar.new,false,true,1) if @ftp.class==Array
	end
	attr_accessor :pc, :progress, :ftp
	
	def item
		@pc.item
	end
  
	def update(nfilename=item['default'])
		run_events(item['id'],'info_item-BeforeUpdate')
		edebug("filename to set: |#{nfilename}|","list-filechooser","debug")
		set_current_name(nfilename) if nfilename
		run_events(item['id'],'info_item-AfterUpdate')
	end
	
	def text
		filename[current_folder.length() +1 .. filename.length()]
	end
	
	def load
		ret=String.new
		file = File.new(filename, "rb")
		ret=file.read
		file.close
		edebug("loaded","list-filechooser","debug")
		set_conf(0,item['id'],"path",current_folder) 
		ret
	end
	
	def save(content)
		file = File.new(filename, "wb+")
		file.write(content)
		file.close
		edebug("saved","list-filechooser","debug")
		set_conf(0,item['id'],"path",current_folder) 
	end
	
	def ftp_store
		unless @ftp.class==Array
			warn("no ftp access defined")
			return false
		end
		set_conf(0,item['id'],"path",current_folder)
  	ftp=Net::FTP.new(@ftp[0],@ftp[1],@ftp[2])
  	@ftp[3].each("/"){|s|
			begin
				einfo("changing ftp dir: #{s}","form")
				ftp.chdir(s)
			rescue =>err
				einfo("creating ftp dir: #{s}","form")
				ftp.mkdir(s)
				retry
			end
		} if @ftp[3]
  	perc=0
  	ftp.putbinaryfile(filename,text,File.size(filename)/100){
  		progress.set_fraction(perc/100.0)
  		Gtk.show_thread_changes
  		perc+=1
  	}
  	ftp.close
	end

	def ftp_get
		unless @ftp.class==Array
			warn("no ftp access defined")
			return false
		end
		set_conf(0,item['id'],"path",current_folder)
  	ftp=Net::FTP.new(@ftp[0],@ftp[1],@ftp[2])
  	@ftp[3].each("/"){|s|
			einfo("changing ftp dir: #{s}","form")
			ftp.chdir(s)
		} if @ftp[3]
  	perc=0
  	einfo(item["initial"],"form")
  	ftp.getbinaryfile(item["initial"],filename,ftp.size(item["initial"])/100){
  		progress.set_fraction(perc/100.0)
  		Gtk.show_thread_changes
  		perc+=1
  	}
  	ftp.close
	end

	
	def loadPixbuf
		set_conf(0,item['id'],"path",current_folder) 
		pixdata=Gdk::Pixdata.from_pixbuf(Gdk::Pixbuf.new(filename),true)
		pixdata.serialize.pack("c*")
	end
end

