#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class MyRendererList < Gtk::VBox
	include Observable
	include ManqodCommon
	
	class ListButton < Gtk::Button
		def initialize
			super()
			set_label("")
			set_image(Gtk::Image.new(Gtk::Stock::INDEX,Gtk::IconSize::MENU))
			set_relief(Gtk::ReliefStyle::NONE)
		end
		
		def update(notifier)
			set_image(Gtk::Image.new(
				case notifier.parentM.runmode
					when "info" then Gtk::Stock::INFO
					when "wysiwygf" then Gtk::Stock::PROPERTIES
					else if notifier.text=="-1" or notifier.text=="" then Gtk::Stock::ADD else Gtk::Stock::EDIT end
				end ,Gtk::IconSize::MENU))
		end
	end
	
	class List < Gtk::TreeView
	include ManqodCommon
	include GtkAttributes
	include	Conf
		def initialize(pc)
			@pc=pc
			super()
			set_enable_grid_lines(case get_conf(0,0,"form-grid")
				when "both" then Gtk::TreeView::GridLines::BOTH
				when "vertical" then Gtk::TreeView::GridLines::VERTICAL
				when "horizontal" then Gtk::TreeView::GridLines::HORIZONTAL
					else Gtk::TreeView::GridLines::NONE
				end
			) if Gtk.check_version?(2,10,9)
			set_enable_tree_lines(true)
			set_rules_hint(true)
			set_enable_search(false)
		end
		attr_accessor :pc
		
		def update(id_to_select)
			model.update
			set_headers_visible(model.header_descriptions?)
			set_selected(id_to_select)
		end

		def item
			pc.item
		end
		
		def parentselected
			pc.parentselected
		end
		
		def parentM
			pc.parentM
		end
		
		def text
			pc.text
		end
		
		def set_selected(id_to_select)
			id_iter=nil
			model.each{|model,path,iter|
				if iter[0]==id_to_select.to_s
					id_iter=iter
					expand_to_path(id_iter.path)
					selection.select_iter(id_iter)
					scroll_to_cell(path,nil,false,0,0)
					break
				end
			}
			!id_iter.nil?
		end
	end
	
	def initialize(pc)
		@pc=pc
		@list=List.new(self)
		@scroller=Gtk::ScrolledWindow.new
		buttons=Gtk::HButtonBox.new.set_layout_style(Gtk::ButtonBox::END)
		super()
		pack_start(scroller)
		pack_start(buttons,false,false) unless target.to_i == -1
		button=ListButton.new
		pc.add_observer(button)
		button.signal_connect('clicked') do |c|
			@form=Myform::MyFormHolder.new("dialog",self,@pc.target_runmode,target)
			@form.set_parentM(parentM)
			ret=form.run(text.to_i)
			list.update(ret) if ret and ret>0
		end
		buttons.pack_start(button)
		scroller.set_hscrollbar_policy(Gtk::POLICY_AUTOMATIC).add(list)
		list.set_model(@model=MyRendererModel.new(list))
		list.selection.signal_connect('changed'){|me|
				if me.selected then 
					edebug("#{self} selection changed by user: #{pc.default} -> #{me.selected[0]}. emiting signal","list-list","debug")
					pc.changed
					pc.notify_observers(pc)
					run_events(item['id'],'form_item-Action')
				end
			}

#		signal_connect('key-press-event'){|me,key| list.model.update_filter(me,key)}
	end
	attr_accessor :pc, :scroller
	attr_accessor :list, :model
	attr_accessor :form
  
	def item
		pc.item
	end
  
	def parentM
		pc.parentM
	end

	def text
		list.selection.selected[0] if !list.selection.selected.nil?
	end
	
	def set_selected(id_to_select)
		list.set_selected(id_to_select)
	end

	def update(id_to_select=item['default'])
		run_events(item['id'],'form_item-BeforeUpdate')
		list.update(id_to_select)
		run_events(item['id'],'form_item-AfterUpdate')
	end #update
	
	def set_model(model)
		list.set_model(model)
	end
	
	def parentselected
		pc.parentselected
	end
	
	def set_label(label)
		pc.set_label(label)
	end
	
	def target
		pc.target
	end
	
	def set_sensitive(sens)
		@list.set_sensitive(sens)
		self
	end

	
	def query
		parentM.query
	end
	
	def qrow
		parentM.qrow
	end
	
	def to_s
		"List: (#{item['description']})"
	end
end #class

