#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class MyRendererTimeStamp < Gtk::VBox
	include ManqodCommon
  def initialize(pc)
		@pc=pc
		super()
		pack_start(@calendar=Gtk::Calendar.new)
		pack_start(Gtk::HBox.new.
	  	pack_start(@hw=Gtk::SpinButton.new(0,23,1).set_has_frame(false).set_numeric(true).set_increments(1,10).set_digits(0)).
	  	pack_start(@mw=Gtk::SpinButton.new(0,59,1).set_has_frame(false).set_numeric(true).set_increments(1,10).set_digits(0)).
	  	pack_start(@sw=Gtk::SpinButton.new(0,59,1).set_has_frame(false).set_numeric(true).set_increments(1,10).set_digits(0)),
		true,false)
 		@sw.signal_connect('value_changed'){|me| changed}
 		@mw.signal_connect('value_changed'){|me| changed}
 		@hw.signal_connect('value_changed'){|me| changed}
		@calendar.signal_connect("next-year"){|me| changed}
		@calendar.signal_connect("prev-year"){|me| changed}
		@calendar.signal_connect("month-changed"){|me| changed}
		@calendar.signal_connect("day-selected"){|me| changed}

		@calendar.set_show_details(true)
		@calendar.set_show_week_numbers(true)
		@calendar.show_day_names=true
	end	
	attr_accessor :pc
  
  def item
  	pc.item
  end
  
  def set_sensitive(sens)
  	@calendar.set_sensitive(sens)
  	@hw.set_sensitive(sens)
  	@mw.set_sensitive(sens)
  	@sw.set_sensitive(sens)
  end
  
	def update(new_value=item['default'])
		new_value=Time.new.to_i if new_value == ""
		item['default']=new_value
		run_events(item['id'],'form_item-BeforeUpdate')
		pc.run_query
		time_to_wg(item['default']) if item['default']
		run_events(item['id'],'form_item-AfterUpdate')
	end
	def changed
			edebug("#{self} changed to #{wg_to_time}","form","debug")
			pc.changed
			pc.notify_observers(self)
			edebug("#{self} emiting 'changed' to observers","form","debug")
			run_events(item['id'],'form_item-Action')
	end
	def text
		wg_to_time.to_s
	end
	def wg_to_time
		begin
			Time.mktime(@calendar.date[0],@calendar.date[1],@calendar.date[2],@hw.value,@mw.value,@sw.value).to_i
		rescue => err
			eerror(err)
		end
	end
	def time_to_wg(d)
		t=Time.at(d.to_i)
		@hw.set_value(t.hour)
		@mw.set_value(t.min)
		@sw.set_value(t.sec)
		@calendar.set_year(t.year).set_month(t.month-1).set_day(t.day).mark_day(t.day)
	end

	def parentselected
		pc.parentselected
	end
  
	def parentM
		pc.parentM
	end
end

