#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class GtkAttributeStorage
	include Singleton
	include Eprint
	
	def load_all
		@gtk_attributes=ManqodDB.instance.cache.get("attributes")
		@gtk_attributes=Hash.new unless @gtk_attributes.class.name == "Hash"
		einfo("loaded #{@gtk_attributes.size} attributes","main")
	end


	def gtk_attribute(gtk_attr, gtk_objectid, gtk_objecttype)
		(@gtk_attributes.has_key?(gtk_objectid) ? 
			( (@gtk_attributes[gtk_objectid].has_key?(gtk_objecttype)) ? 
				@gtk_attributes[gtk_objectid][gtk_objecttype][gtk_attr] : nil) : nil )
	end

	def set_gtk_attribute(gtk_attr,gtk_attr_value, gtkobjectid, gtkobjecttype)
		@gtk_attributes=Hash.new if @gtk_attributes.nil?
		@gtk_attributes[gtkobjectid]=Hash.new unless @gtk_attributes.has_key?(gtkobjectid)
		@gtk_attributes[gtkobjectid][gtkobjecttype]=Hash.new unless @gtk_attributes[gtkobjectid].has_key?(gtkobjecttype)
		@gtk_attributes[gtkobjectid][gtkobjecttype][gtk_attr]=nil unless @gtk_attributes[gtkobjectid][gtkobjecttype].has_key?(gtk_attr)
		@gtk_attributes[gtkobjectid][gtkobjecttype][gtk_attr]=gtk_attr_value
		einfo("set attribute [#{gtkobjecttype}][#{gtkobjectid}][#{gtk_attr}]=\"#{gtk_attr_value}\"","main")
	end

	def to_s;"GtkAttributeStorage";end
end

module GtkAttributes

	def gtk_attribute(gtk_attr)
		GtkAttributeStorage.instance.gtk_attribute(gtk_attr, gtkobjectid, gtkobjecttype) || GtkAttributeStorage.instance.gtk_attribute(gtk_attr, "0", gtkobjecttype)
	end

	def gtk_attribute_of_object(gtk_attr,gtkobject_id,gtkobject_type)
		GtkAttributeStorage.instance.gtk_attribute(gtk_attr, gtkobject_id, gtkobject_type)
	end

	def set_gtk_attribute(gtk_attr,gtk_attr_value)
		GtkAttributeStorage.instance.set_gtk_attribute(gtk_attr,gtk_attr_value, gtkobjectid, gtkobjecttype)
	end

	def default_attribute(gtk_attr)
		GtkAttributeStorage.instance.gtk_attribute(gtk_attr, "0", gtkobjecttype)
	end

	def gtkobjectid
		case self.class.name
			when "MyEditableList" then list_id.to_s
			when "MyColumn" then header["id"].to_s
			when "Myform::MyForm" then get_id.to_s
			when "MyButton"	then properties["id"].to_s
			when "MyInputHolder","MyRendererList::List","MyRendererCombo","MyRendererConstCombo","FieldCombo" then item["id"].to_s
			else 
			edebug("unsupported class in gtk_attributes: #{self.class.name} for #{self}","main","error")
		end
	end

	def gtkobjecttype
		case self.class.name
			when "MyEditableList" then "list"
			when "MyColumn" then "list_column"
			when "Myform::MyForm" then "form"
			when "MyButton" then "list-button"
			when "MyInputHolder","MyRendererList::List","MyRendererCombo","MyRendererConstCombo","FieldCombo" then "form-item"
			else edebug("unsupported class in gtk_attributes: #{self.class.name} for #{self}","main","error")
		end
	end

end

