#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class SumRendererText < Gtk::Label
	include ManqodCommon
	def initialize(column)
		@column=column
		@decimals=case column.header["type"]
			when "gtk_float" then 2
			else 0
		end
		super()
		set_alignment(column.alignment,0.5)
	end
	attr_accessor :column
	
	def update(new_value=0)
		set_text(case column.header['type']
			when "gtk_int" then number_format(new_value,@column.decimals_attribute)
			when "gtk_float" then number_format(new_value,@column.decimals_attribute)
			when "gtk_duration" then new_value.to_i.strftime(column.duration_format)
		end)
	end
	
	def to_s
		"SumRenderer of #{column}"
	end
	def inspect
		to_s
	end
end
