#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class FormatTagTable < Gtk::TextTagTable
	def initialize(browser)
		@browser=browser
		super()
	end
	attr_reader :browser

	def add(arg)
		tag=FormatTag.new(self,arg)
		super(tag) if tag.name
		tag
	end

	def markup_regexp
		r=""
		each{|tag| r=r+tag.code+"|" if tag.code && tag.code.length>1}
		r[r.length-1]="" if r.length>0 #remove the last |
		Regexp.compile(r)
	end

	def lookup_by_code(str)
		found=nil
		each{|tag| found=tag if tag.code == Regexp.escape(str)}
		found
	end
	def lookup(name)
		name.nil? ? nil : super(name)
	end
	def clear
		a=Array.new
		each{|tag| a.push(tag)}
		a.each{|tag| remove(tag)}
	end
end

