#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class HelpIndex < Gtk::ScrolledWindow
	def initialize(help)
		@help=help
		@path=Array.new
		super()
		set_policy(Gtk::POLICY_AUTOMATIC,Gtk::POLICY_AUTOMATIC)
		@data=Gtk::ListStore.new(String,TrueClass)
		@filter=Gtk::TreeModelFilter.new(@data)
		@filter.set_visible_column(1)
		@sorter=Gtk::TreeModelSort.new(@filter).set_sort_column_id(0)
		@widget=Gtk::TreeView.new(@sorter)
		column=Gtk::TreeViewColumn.new("Index",renderer=Gtk::CellRendererText.new, {:text => 0}).set_sort_column_id(0)
		@widget.append_column(column)
		add_with_viewport(@widget)
		@widget.signal_connect("cursor-changed"){|me|
			if me.cursor
				item=@sorter.get_iter(me.cursor[0])[0]
				@path.push(item) if help.browser.load_item(item)
				@help.update_back_button
			end
		}

	end
	attr_reader :help
	def populate
		@data.clear
		@help.browser.items.each_key{|key|
			i=@data.append
			i[0]=key
			i[1]=true
		}
		self
	end
	def refilter
		@data.each{|model,path,iter|
			iter[1]=iter[0].upcase.index(@help.filter.text.upcase) != nil
		}
		@filter.refilter
	end
	def set_cursor(item)
		found=nil
		loaded=false
		@data.each{|model,path,iter| found=path if item.upcase == iter[0].upcase}
		loaded=@widget.set_cursor(@sorter.convert_child_path_to_path(@filter.convert_child_path_to_path(found)),nil,false) if found
		loaded
	end
	def go_back
		if can_go_back?
			@path.pop
			set_cursor(@path.pop)
			@help.update_back_button
		end
	end
	def can_go_back?
		@path.size > 1
	end
end

