#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class ManqodRPC
	include DRb
	include DRbUndumped
	include Singleton
	include ManqodCommon
	def alive?
		true
	end
	def start_service(client_uri)
		@client_server=DRb.start_service(client_uri,self)
	end
	def connect_to(server_uri)
		@manqod_server=DRb::DRbObject.new(nil,server_uri)
	end
	def unregister_client
		manqod_server.unregister_client(ManqodRPC.instance.to_s)
	end
	def register_client
		manqod_server.register_client(ManqodRPC.instance.to_s,self,ManqodDB.instance.manqod_db.name.to_s)
	end
	def nick
		Nick.instance.get_nick
	end
	def to_s
		"#{Nick.instance.get_nick}@#{@client_server.uri}"
	end
	def rpc(proc)
		einfo("RPC:#{proc}","main")
		eeval(proc,self)
	end
	attr_reader :manqod_server, :client_server
end

