#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class MyConfig < Gtk::Table
	class ConfComboHolder < Gtk::HBox
		include Conf
		class ConfCombo < Gtk::ComboBox
			include Conf
			def initialize(values)
				super(Gtk::ListStore.new(String,String))
				pack_start(renderer=Gtk::CellRendererText.new,true).add_attribute(renderer,:text,1)
				values.each_pair{|key,value| model.append.set_value(0,key).set_value(1,value)}
				signal_connect('changed'){|me| 
					set_conf(0,0,parent.conf_text,me.active_iter[0])
				}
			end
			def set_active(defval)
				model.each{|model,path,iter| set_active_iter(iter) if iter[0] == defval}
			end
		end
		
		def initialize(label_text,conf_text,values)
			@conf_text=conf_text
			super()
			pack_start(Gtk::Label.new(label_text).set_alignment(0,0.5))
			pack_end(@combo=ConfCombo.new(values))
		end
		attr_accessor :conf_text
		
		def update
			@combo.set_active(get_conf(0,0,@conf_text))
		end
	end
	
	class ConfFontHolder < Gtk::HBox
		include Conf
		def initialize(label_text,conf_text)
			@conf_text=conf_text
			super()
			pack_start(Gtk::Label.new(label_text).set_alignment(0,0.5))
			pack_end(@font_button=Gtk::FontButton.new)
			@font_button.signal_connect('font-set'){|me| set_conf(0,0,@conf_text,me.font_name)}
			@font_button.set_use_font(true)
		end
		attr_accessor :conf_text
		
		def update
			@font_button.set_font_name(get_conf(0,0,@conf_text))
		end
	end
	
	def initialize
		super(2,4)
		@items=Array.new
		@items.push(ConfComboHolder.new("Button size","button-size",{"gtk-button"=>"Button","gtk-dialog" => "Dialog", "gtk-dnd" => "Dnd","gtk-large-toolbar"=>"Large Toolbar","gtk-menu"=>"Menu","gtk-small-toolbar"=>"Small Toolbar"}))
		@items.push(ConfComboHolder.new("List image size","list-image-size",{"gtk-button"=>"Button","gtk-dialog" => "Dialog", "gtk-dnd" => "Dnd","gtk-large-toolbar"=>"Large Toolbar","gtk-menu"=>"Menu","gtk-small-toolbar"=>"Small Toolbar"}))
		@items.push(ConfComboHolder.new("Grid in Lists in Forms","form-grid",{"both"=>"Both","vertical"=>"Vertical","horizontal"=>"Horizontal","none"=>"None"}))
		@items.push(ConfComboHolder.new("Grid in Lists","grid",{"both"=>"Both","vertical"=>"Vertical","horizontal"=>"Horizontal","none"=>"None"}))
		@items.push(ConfComboHolder.new("Tooltip in Lists","list-tooltip",{"none"=>"None","filters"=>"Filters"}))
		@items.push(ConfComboHolder.new("Menu Position","menu-position",{"top"=>"Top","bottom"=>"Bottom","left"=>"Left","right"=>"Right"}))
		@items.push(ConfComboHolder.new("Menu Type","menu-type",{"buttons"=>"Buttons","standard"=>"Standard"}))
		@items.push(ConfComboHolder.new("Confirm Exit","confirm-exit",{"true"=>"Confirm","false"=>"Just exit"}))
		
		@items.push(ConfFontHolder.new("Info Frame Font","info-frame-font"))
		@items.push(ConfFontHolder.new("Info Item Font","info-item-font"))

		@items.push(ConfFontHolder.new("Form Frame Font","form-frame-font"))
		@items.push(ConfFontHolder.new("Form Item Font","form-item-font"))

		@items.push(ConfFontHolder.new("List Button Font","list-button-font"))
		@items.push(ConfFontHolder.new("List Cell Font","list-cell-font"))
		@items.push(ConfFontHolder.new("Standard Menu Font","bar-menu-font"))

		y=0
		@items.each{|item|
			attach(item,0,1,y,y+1,Gtk::EXPAND|Gtk::FILL,Gtk::EXPAND)
			y+=1
		}
		
		show_all
	end
	
	
	def update(notifier=nil)
		@items.each{|item| item.update}
	end
	
	def title
		"Config"
	end
end

