#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class TextLayout
	def initialize(cr,txt,font,width,x,y,alignment='left')
		@cr=cr
		@font=font
		@layout=cr.create_pango_layout
		@txt=txt
		@layout.set_text(txt)
		@x=x
		@y=y
		@width=width
		@alignment=alignment
		@layout.set_font_description(Pango::FontDescription.new(@font)).set_width(@width*Pango::SCALE)
		@layout.set_wrap(Pango::Layout::WRAP_WORD_CHAR).set_ellipsize(Pango::Layout::ELLIPSIZE_NONE)#.set_single_paragraph_mode(true)
		set_alignment
	end
	attr_reader :layout

	def set_x(newx=x)
		@x=newx
	end
	def set_y(newy=y)
		@y=newy
	end
	def set_alignment(alignment=@alignment)
		@alignment=alignment
		case @alignment
			when 'left' then @layout.set_alignment(Pango::Layout::ALIGN_LEFT)
			when 'right' then @layout.set_alignment(Pango::Layout::ALIGN_RIGHT)
			when 'center' then @layout.set_alignment(Pango::Layout::ALIGN_CENTER)
		end
	end
	def height
		w,h=@layout.size
		h/Pango::SCALE
	end

	def draw(cr)
		cr.move_to(@x,@y)
		cr.show_pango_layout(@layout)
		cr.stroke
	end
end

