#this file is part of manqod
#manqod is distributed under the CDDL licence
#the author of manqod is Dobai-Pataky Balint(dpblnt@gmail.com)

class MyListProgress < Gtk::ProgressBar
	def initialize
		@counter=0.0
		@max=nil
		@visible_steps=1
		@progresses=Hash.new
		@list_name=nil
		@frac=0
		@pfrac=0
		super()
#		modify_font(Pango::FontDescription.new('Monospace 3'))
		set_height_request(6)
		set_width_request(100)
		set_activity_mode(false)
		modify_font(Pango::FontDescription.new("sans 7"))
#		set_show_text(false)
		@pulse_thread=nil
	end
	attr_reader :counter, :max, :visible_steps
	attr_accessor :done

	def start_pulse
		@pulse_thread=Thread.new{
			loop do
				sleep 0.1
				Gtk.thread_protect{pulse unless destroyed?}
				Gtk.show_thread_changes
			end
		}
	end

	def zero(new_max,list_name=nil)
		Thread.kill(@pulse_thread) unless @pulse_thread.nil?
		@pulse_thread=nil
		@max=new_max
		@done=false
		set_counter(0)
		if @list_name!=list_name
			@list_name=list_name
			Gtk.thread_protect{set_text(@list_name) unless destroyed?}
		end
		self
	end
	def set_visible_steps(new_vs)
		@visible_steps=new_vs.to_f
		self
	end

	def set_counter(new_counter)
		new_counter=max if new_counter>max
		@counter=new_counter.to_f
		
		if max==0
			@frac=0
			else
			@frac=counter.to_f/max.to_f
=begin
			if counter==0
				else
				set_text((100.0*counter/max).round.to_s+"%")
			end
=end
		end
		if (@pfrac*100/visible_steps).round!=(@frac*100/visible_steps).round
			Gtk.thread_protect{set_fraction(@frac) unless destroyed?}
			Gtk.show_thread_changes
			@pfrac=@frac
		end
	end

end

class MultiProgress < Gtk::HBox
	def initialize
		@max=0
		super()
		@progresses=Hash.new
		signal_connect("destroy"){|me| @progresses.each_value{|progress| progress.destroy} }
	end
	
	def pulse(list_id)
		#init the progress
		unless @progresses.has_key?(list_id)
			@progresses[list_id]=MyListProgress.new
			pack_start(@progresses[list_id])
			@progresses[list_id].show
		end
		SB.instance.show

		@progresses[list_id].start_pulse
	end

	def zero(list_id,rowcount,list_name=nil,visible_steps=15)
		#init the progress
		unless @progresses.has_key?(list_id)
			@progresses[list_id]=MyListProgress.new
			@progresses[list_id].set_visible_steps(visible_steps)
			pack_start(@progresses[list_id])
			@progresses[list_id].show
		end

		@progresses[list_id].zero(rowcount,list_name) unless @progresses[list_id].destroyed?
		SB.instance.show
		self
	end

	def step(list_id,new_value)
		if @progresses.has_key?(list_id)
			@progresses[list_id].set_counter(new_value) unless @progresses[list_id].destroyed?
			SB.instance.show unless SB.instance.visible?
		end
#		sleep 0.1
		self
	end

	def done(list_id)
		@progresses[list_id].done=true if @progresses.has_key?(list_id)
		if all_done?
			@progresses.each_value{|progress| 
				remove(progress)
				progress.destroy
			}
			@progresses.clear
		end
		SB.instance.show unless SB.instance.visible?
	end
	
	def killed(list_id)
		if @progresses.has_key?(list_id)
			pr=@progresses.delete(list_id)
			remove(pr)
			pr.destroy
			p pr.destroyed?
		end
	end

	def all_done?
		d=0
		@progresses.each_value{|progress| d+=1 if progress.done}
		@progresses.size == d
	end
	def to_s
		"MultiProgress"
	end
end

